# Dynamically Generated
@builtin "number.ne"
@builtin "string.ne"
@builtin "whitespace.ne"
@{%
    function compact(v) {
        if (Array.isArray(v)) {
            return v.reduce((a, v) => (v === null || v === undefined || (v && v.length === 0) ) ? a : (a.push(v), a), []);
        } else {
            return v;
        }
    }

    function flatten(v) {
        let r;
        if (Array.isArray(v)) {
            r = v.reduce((a,v) => (a.push(...((v && Array.isArray(v)) ? flatten(v) : [v])), a), []);
        } else {
            r = v;
        }
        r = compact(r);
        return r;
        }
%}


rule -> rule1 rule2 rule3 rule4 rule5 rule6 rule7 rule8 rule9 rule10 rule11 rule12 rule13 rule14 rule15 rule16 rule17 rule18 rule19 rule20 rule21 rule22 rule23 rule24 rule25 rule26 rule27 rule28 rule29 rule30 rule31 rule32 rule33 rule34 rule35 rule36 rule37 rule38 rule39 rule40 rule41 rule42 
{% ([ rule1,rule2,rule3,rule4,rule5,rule6,rule7,rule8,rule9,rule10,rule11,rule12,rule13,rule14,rule15,rule16,rule17,rule18,rule19,rule20,rule21,rule22,rule23,rule24,rule25,rule26,rule27,rule28,rule29,rule30,rule31,rule32,rule33,rule34,rule35,rule36,rule37,rule38,rule39,rule40,rule41,rule42 ]) => {
    return {
        $class: "org.accordproject.safte.TemplateModel",
        
        companyName : rule1,
        companyRegistrationNumber : rule11,
        purchaser : rule3,
        jurisdiction : rule9,
        purchaseAmount : rule5,
        discount : rule15,
        projectName : rule13,
        projectDescription : rule19,
        months : rule23,
        monthsText : rule21,
        amount : rule25,
        amountText : rule27
    };
}
%}

ROOT -> rule0 
{% ([ rule0 ]) => {
    return {
        
        
    };
}
%}



rule1 -> String {% id %} # companyName 


rule2 -> "\n\nSAFTE \n(Simple Agreement for Future Tokens or Equity)\n\nTHIS CERTIFIES THAT in exchange for the payment by " 


rule3 -> String {% id %} # purchaser 


rule4 -> " (the “Purchaser”) of $" 


rule5 -> Double {% id %} # purchaseAmount 


rule6 -> " (the “Purchase Amount”) to " 


rule7 -> String {% id %} # companyName 


rule8 -> ", a limited company incorporated in " 


rule9 -> State {% id %} # jurisdiction 


rule10 -> " with company number " 


rule11 -> Long {% id %} # companyRegistrationNumber 


rule12 -> " (the “Company”), the Company hereby issues to the Purchaser the right to either:- (1) cryptographic tokens in the " 


rule13 -> String {% id %} # projectName 


rule14 -> " (the “Tokens”); or (2) certain shares in the Company’s share capital, in either case on the terms set forth below. \nThe “Discount Rate” is 100 minus " 


rule15 -> Double {% id %} # discount 


rule16 -> "%.\nSee Section 2 for certain additional defined terms.\n1.	Events\n\n	(a) 	Token Sale. In the event that the Company or any Nominated Entity operates a Qualifying Token Sale, the Company will automatically issue to the Purchaser, or will take all reasonable steps to procure that the Nominated Entity promptly issues to the Purchaser, a number of Tokens equal to the Purchase Amount divided by the Discount Rate (the Purchaser Tokens). If the Qualifying Token Sale is offered at different prices depending on the time at which Tokens are purchased, the Purchase Amount will be considered to have been at the most advantageous rate publicly marketed.\nIf the Company elects to operate the Qualifying Token Sale using a Nominated Entity, it will inform the Purchaser in writing. The performance by the Nominated Entity of the obligations of the Company under this agreement will duly discharge the obligations of the Company to the Purchaser. \n	(b)	Equity Financing. If there is an Equity Financing before the expiration or termination of this agreement, and the Purchaser has not received Purchaser Tokens pursuant to Section 1(a), the Company will automatically issue to the Purchaser a number of SAFTE Shares equal to the Purchase Amount divided by the Discount Price.\n	In connection with the issuance of SAFTE Shares by the Company to the Purchaser pursuant to this Section 1(b): \n(i) The Purchaser will execute and deliver to the Company all transaction documents related to the Equity Financing; provided, that such documents are the same documents to be entered into with the purchasers of Equity Financing Shares, with appropriate variations for the SAFTE Shares if applicable, and provided further, that such documents have customary exceptions to any drag-along rights and obligations applicable to the Purchaser, including, without limitation, limited representations and warranties and limited liability and indemnification obligations on the part of the Purchaser; and \n(ii)	The Purchaser and the Company will execute a Pro Rata Rights Agreement, unless the Purchaser is already included in such rights in the transaction documents related to the Equity Financing.\n		(c)	Dissolution Event. If there is a Dissolution Event before this agreement expires or terminates, the Company will pay an amount equal to the Purchase Amount, due and payable to the Purchaser immediately prior to, or concurrent with, the consummation of the Dissolution Event. The Purchase Amount will be paid prior and in preference to any Distribution of any of the assets of the Company to holders of outstanding Capital Shares by reason of their ownership thereof. If immediately prior to the consummation of the Dissolution Event, the assets of the Company legally available for distribution to the Purchaser and all holders of all other SAFTEs (the “Dissolving Purchasers”), as determined in good faith by the Company’s board of directors, are insufficient to permit the payment to the Dissolving Purchasers of their respective Purchase Amounts, then the entire assets of the Company legally available for distribution will be distributed with equal priority and pro rata among the Dissolving Purchasers in proportion to the Purchase Amounts they would otherwise be entitled to receive pursuant to this Section 1(c).\n	(d)	Termination.  This agreement will expire and terminate (without relieving the Company of any obligations arising from a prior breach of or non-compliance with this agreement) upon either (i) the issuance of Tokens to the Purchaser pursuant to Section 1(a); or (ii) the issuance of shares to the Purchaser pursuant to Section 1(b); or (iii) the payment, or setting aside for payment, of amounts due the Purchaser pursuant to Section 1(c).\n\n2.	Definitions\n\n	“Acting in Concert” has the meaning given to it in the City Code on Takeovers and Mergers published by the Panel on Takeovers and Mergers in force from time to time.\n\n	“Capital Shares” means the share capital of the Company, including, without limitation, the “Equity Financing Shares” and the “SAFTE Shares.”\n	“Change of Control” means (i) a transaction or series of related transactions in which more than fifty per cent (50 %) of the voting rights attaching to the Capital Shares of the Company are sold or are to be sold to one person or group of persons Acting in Concert; or (ii) a sale, lease or other disposition of all or substantially all of the assets of the Company.  \n“" 


rule17 -> String {% id %} # projectName 


rule18 -> "” means a suite of smart contracts built on the Ethereum Network which " 


rule19 -> String {% id %} # projectDescription 


rule20 -> ".\n	“Discount Price” means (i) the price per share of the Equity Financing Shares sold in the Equity Financing multiplied by the Discount Rate, or (ii) the price per token of the Token sold in the Qualifying Token Sale multiplied by the Discount Rate. \n	“Distribution” means the transfer to holders of Capital Shares by reason of their ownership thereof of cash or other property without consideration whether by way of dividend or otherwise, other than dividends on ordinary shares payable in ordinary shares, or the purchase or redemption of Capital Shares by the Company or its subsidiaries for cash or property other than: (i) repurchases of ordinary shares held by employees, officers, directors or consultants of the Company or its subsidiaries pursuant to an agreement providing, as applicable, a right of first refusal or a right to repurchase shares upon termination of such service provider’s employment or services; or (ii) repurchases of Capital Shares in connection with the settlement of disputes with any shareholder.\n\n	“Dissolution Event” means (i) a voluntary termination of operations, (ii) a general assignment for the benefit of the Company’s creditors or (iii) any other liquidation, dissolution or winding up of the Company (excluding a Liquidity Event), whether voluntary or involuntary.\n	“Equity Financing” means a bona fide transaction or series of transactions with the principal purpose of raising capital, where the Company raises during any consecutive " 


rule21 -> String {% id %} # monthsText 


rule22 -> " " 


rule23 -> Integer {% id %} # months 


rule24 -> " month(s) period in aggregate over " 


rule25 -> Double {% id %} # amount 


rule26 -> " " 


rule27 -> String {% id %} # amountText 


rule28 -> " from an Purchaser or number of Purchasers, and pursuant to which the Company issues and sells either ordinary or preferred shares at a fixed pre-money valuation. \n“Equity Financing Shares” means the shares issued as part of the Equity Financing. \n	\n	“Liquidity Event” means a Change of Control or a Listing. \n\n	“Liquidity Price” means the price per share equal to: the fair market value of the SAFTE Shares at the time of the Liquidity Event, as determined by reference to the purchase price payable in connection with such Liquidity Event, divided by the Discount Rate. \n\n	“Listing” means a listing of the Capital Shares on a recognised stock exchange or other active secondary market. \n“Investment Amount” means the amounts paid by the Purchaser to the Company pursuant to this agreement.\n“Nominated Entity” means a company or other organisation, nominated by the Company to operate the Qualifying Token Sale.	\n“Pro Rata Rights Agreement” means a written agreement between the Company and the Purchaser (and holders of other SAFTEs, as appropriate) giving the Purchaser a right to purchase its pro rata share of private placements of securities by the Company occurring after the Equity Financing, subject to customary exceptions.  Pro rata for purposes of the Pro Rata Rights Agreement will be calculated based on the ratio of (1) the number of shares of Capital Shares owned by the Purchaser immediately prior to the issuance of the securities to (2) the total number of shares of outstanding Capital Shares on a fully diluted basis, calculated as of immediately prior to the issuance of the securities.  	\n“Qualifying Token Sale” means the operation by the Company or any subsidiary thereof of a public sale of cryptographic tokens necessary for the operation of the " 


rule29 -> String {% id %} # projectName 


rule30 -> ". \n	 “SAFTE” means an agreement containing a future right to shares of Capital Shares, similar in form and content to this agreement, purchased by Purchasers for the purpose of funding the Company’s business operations.\n	“SAFTE Shares” means shares in the Company having the identical rights, privileges, preferences and restrictions as the Equity Financing Shares, other than with respect to: (i) the per share liquidation preference and the conversion price for purposes of price-based anti-dilution protection, which will equal the Discount Price; and (ii) the basis for any dividend rights, which will be based on the Discount Price.\n	“Token Sale” means the public sale of cryptographic tokens in the " 


rule31 -> String {% id %} # projectName 


rule32 -> " as seen as necessary for the running of the " 


rule33 -> String {% id %} # projectName 


rule34 -> ".\n\n 3.	Company Representations\n	(a)	The Company is duly incorporated and validly existing under the laws of " 


rule35 -> State {% id %} # jurisdiction 


rule36 -> ", and has the power and authority to own, lease and operate its properties and carry on its business as now conducted.\n	(b)	The execution, delivery and performance by the Company of this agreement is within the power of the Company and, other than with respect to the actions to be taken when equity is to be issued to the Purchaser, has been duly authorized by all necessary actions on the part of the Company. This agreement constitutes a legal, valid and binding obligation of the Company, enforceable against the Company in accordance with its terms, except as limited by bankruptcy, insolvency or other laws of general application relating to or affecting the enforcement of creditors’ rights generally and general principles of equity.  To the knowledge of the Company, it is not in violation of (i) its current certificate of incorporation or articles of association, (ii) any material statute, rule or regulation applicable to the Company or (iii) any material indenture or contract to which the Company is a party or by which it is bound, where, in each case, such violation or default, individually, or together with all such violations or defaults, could reasonably be expected to have a material adverse effect on the Company.\n	(c)	The performance and consummation of the transactions contemplated by this agreement do not and will not: (i) violate any material judgment, statute, rule or regulation applicable to the Company; (ii) result in the acceleration of any material indenture or contract to which the Company is a party or by which it is bound; or (iii) result in the creation or imposition of any lien upon any property, asset or revenue of the Company or the suspension, forfeiture, or nonrenewal of any material permit, license or authorization applicable to the Company, its business or operations.\n	(d)	No consents or approvals are required in connection with the performance of this agreement, other than: (i) the Company’s corporate approvals; (ii) any qualifications or filings under applicable securities laws; and (iii) necessary corporate approvals for the authorization of Capital Shares issuable pursuant to Section 1.\n	(e)	To its knowledge, the Company owns or possesses (or can obtain on commercially reasonable terms) sufficient legal rights to all patents, trademarks, service marks, trade names, copyrights, trade secrets, licenses, information, processes and other intellectual property rights necessary for its business as now conducted and as currently proposed to be conducted, without any conflict with, or infringement of the rights of, others.\n\n4.	Purchaser Representations\n	(a)	The Purchaser has full legal capacity, power and authority to execute and deliver this agreement and to perform its obligations hereunder. This agreement constitutes valid and binding obligation of the Purchaser, enforceable in accordance with its terms, except as limited by bankruptcy, insolvency or other laws of general application relating to or affecting the enforcement of creditors’ rights generally and general principles of equity. \n	(b)	The Purchaser is purchasing this agreement and the securities to be acquired by the Purchaser hereunder for its own account for investment, not as a nominee or agent, and not with a view to, or for resale in connection with, the distribution thereof, and the Purchaser has no present intention of selling, granting any participation in, or otherwise distributing the same. The Purchaser has such knowledge and experience in financial and business matters that the Purchaser is capable of evaluating the merits and risks of such investment, is able to incur a complete loss of such investment without impairing the Purchaser’s financial condition and is able to bear the economic risk of such investment for an indefinite period of time. \n5.	Miscellaneous\n	(a)	Any provision of this agreement may be amended, waived or modified only upon the written consent of the Company and the Purchaser.  \n	(b)	Unless otherwise expressly stated herein, all communications under this agreement will be in writing and may be made by letter or email. Any notice required or permitted by this agreement will be deemed sufficient when delivered personally or by overnight courier or sent by email to the relevant address listed on the signature page, or 48 hours after being deposited in the mail as certified or registered mail with postage prepaid, addressed to the party to be notified at such party’s address listed on the signature page, as subsequently modified by written notice.\n	(c)	The Purchaser is not entitled, as a holder of this agreement, to vote or receive dividends or be deemed the holder of Capital Shares for any purpose, nor will anything contained herein be construed to confer on the Purchaser, as such, any of the rights of a shareholder of the Company or any right to vote for the election of directors or upon any matter submitted to shareholders at any meeting thereof, or to give or withhold consent to any corporate action or to receive notice of meetings, or to receive subscription rights or otherwise until shares have been issued upon the terms described herein.\n	(d)	Neither this agreement nor the rights contained herein may be assigned, by operation of law or otherwise, by either party without the prior written consent of the other.  \n\n	(e) In the event any one or more of the provisions of this agreement is for any reason held to be invalid, illegal or unenforceable, in whole or in part or in any respect, or in the event that any one or more of the provisions of this agreement operate or would prospectively operate to invalidate this agreement, then and in any such event, such provision(s) only will be deemed null and void and will not affect any other provision of this agreement and the remaining provisions of this agreement will remain operative and in full force and effect and will not be affected, prejudiced, or disturbed thereby. \n\n	(f)	This agreement may be executed and delivered in any number of counterparts, each of which when executed and delivered shall constitute a duplicate original, but all the counterparts together shall constitute the one agreement. \n\n	(g) This agreement, and all rights and obligations hereunder, will be governed by and construed in accordance with the laws of " 


rule37 -> State {% id %} # jurisdiction 


rule38 -> ", and the courts of " 


rule39 -> State {% id %} # jurisdiction 


rule40 -> " shall have exclusive jurisdiction to settle any dispute arising in connection with this agreement. \n\nThis agreement has been executed and delivered as a deed on the date appearing at the beginning of this deed.\n\nExecuted and delivered as a deed by " 


rule41 -> String {% id %} # companyName 


rule42 -> ".\n\n" 


ContractState -> String  __  String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractState",
        stateId : data[0],
        contract : data[2]
    };
}
%}


ContractModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractModel",
        contractId : data[0]
    };
}
%}


ClauseModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ClauseModel",
        clauseId : data[0]
    };
}
%}


Request -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Request",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Response -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Response",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


ErrorResponse -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ErrorResponse",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Payload -> ContractModel  __  Request  __  ContractState 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Payload",
        contract : data[0],
        request : data[2],
        state : data[4]
    };
}
%}


Success -> Response  __  ContractState  __  Event:+ 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Success",
        response : data[0],
        state : data[2],
        emit : data[4]
    };
}
%}


Failure -> ErrorResponse 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Failure",
        error : data[0]
    };
}
%}


TokenSale -> Double  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.safte.TokenSale",
        tokenPrice : data[0],
        transactionId : data[2],
        timestamp : data[4]
    };
}
%}


TokenShare -> Double  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.safte.TokenShare",
        tokenAmount : data[0],
        transactionId : data[2],
        timestamp : data[4]
    };
}
%}


EquityFinancing -> Double  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.safte.EquityFinancing",
        sharePrice : data[0],
        transactionId : data[2],
        timestamp : data[4]
    };
}
%}


EquityShare -> Double  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.safte.EquityShare",
        equityAmount : data[0],
        transactionId : data[2],
        timestamp : data[4]
    };
}
%}


DissolutionEvent -> String  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.safte.DissolutionEvent",
        cause : data[0],
        transactionId : data[2],
        timestamp : data[4]
    };
}
%}


PayOut -> Double  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.safte.PayOut",
        amount : data[0],
        transactionId : data[2],
        timestamp : data[4]
    };
}
%}


State -> "AL" {% id %} | "AK" {% id %} | "AZ" {% id %} | "AR" {% id %} | "CA" {% id %} | "CO" {% id %} | "CT" {% id %} | "DE" {% id %} | "FL" {% id %} | "GA" {% id %} | "HI" {% id %} | "ID" {% id %} | "IL" {% id %} | "IN" {% id %} | "IA" {% id %} | "KS" {% id %} | "KY" {% id %} | "LA" {% id %} | "ME" {% id %} | "MD" {% id %} | "MA" {% id %} | "MI" {% id %} | "MN" {% id %} | "MS" {% id %} | "MO" {% id %} | "MT" {% id %} | "NE" {% id %} | "NV" {% id %} | "NH" {% id %} | "NJ" {% id %} | "NM" {% id %} | "NY" {% id %} | "NC" {% id %} | "ND" {% id %} | "OH" {% id %} | "OK" {% id %} | "OR" {% id %} | "PA" {% id %} | "RI" {% id %} | "SC" {% id %} | "SD" {% id %} | "TN" {% id %} | "TX" {% id %} | "UT" {% id %} | "VT" {% id %} | "VA" {% id %} | "WA" {% id %} | "WV" {% id %} | "WI" {% id %} | "WY" {% id %} 



# Basic types
NUMBER -> [0-9] 
{% (d) => {return parseInt(d[0]);}%}

DOUBLE_NUMBER -> NUMBER NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

MONTH -> DOUBLE_NUMBER
DAY -> DOUBLE_NUMBER
YEAR -> DOUBLE_NUMBER DOUBLE_NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

DATE -> MONTH "/" DAY "/" YEAR
{% (d) => {return '' + d[4] + '-' + d[0] + '-' + d[2]}%}

Word -> [\S]:*
{% (d) => {return d[0].join('');}%}

BRACKET_PHRASE -> "[" Word (__ Word):* "]" {% ((d) => {return d[1] + ' ' + flatten(d[2]).join(" ");}) %}

String -> dqstring {% id %}
Double -> decimal {% id %}
Integer -> int {% id %}
Long -> int {% id %}
Boolean -> "true" {% id %} | "false" {% id %}
DateTime -> DATE  {% id %}